#include <amxmodx>
#include <reapi>

#pragma semicolon 1

const MSG_STRLEN = 32;
const MENU_STRLEN = 512;
const RECEIVED_MESSAGE_ARG = 4;

const TIME_MENU = INVALID_HANDLE;
const MENU_KEYS = MENU_KEY_0|MENU_KEY_1|MENU_KEY_2|MENU_KEY_5|MENU_KEY_6;

new const MENU_TAB[] =			"^t^t^t^t";
new const ADVERTISING[] =		"VK.COM/ULTIMA_CS";

public plugin_init() {
	register_plugin("Team Select Menu", "2.0", "Javekson");
	register_message(get_user_msgid("VGUIMenu"), "MsgVGUIMenu");
	register_message(get_user_msgid("ShowMenu"), "MsgShowMenu");
	register_menucmd(register_menuid("_team_select_menu"), MENU_KEYS, "HandleTeamSelectMenu");
}

public MsgVGUIMenu(const iMsgID, const iMsgDest, const iIndex) {
	ShowTeamSelectMenu(iIndex);
	return PLUGIN_HANDLED;
}

public MsgShowMenu(const iMsgID, const iMsgDest, const iIndex) { //setinfo "_vgui_menus" "0"
	new sMessage[MSG_STRLEN];
	get_msg_arg_string(RECEIVED_MESSAGE_ARG, sMessage, charsmax(sMessage));
	//if(equal(sMessage, "#Team_Select") || equal(sMessage, "#Team_Select_Spect") || equal(sMessage, "#IG_Team_Select") || equal(sMessage, "#IG_Team_Select_Spect")) {
	if(contain(sMessage, "Team_Select") != INVALID_HANDLE) {
		ShowTeamSelectMenu(iIndex);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public ShowTeamSelectMenu(const id) {
	new sMenu[MENU_STRLEN], iLenMenu = formatex(sMenu, charsmax(sMenu), "%s\r%s^n%s\yМеню выбора команды^n^n", MENU_TAB, ADVERTISING, MENU_TAB);
	new bsKeys = MENU_KEY_1|MENU_KEY_2|MENU_KEY_5|MENU_KEY_6;
	iLenMenu += formatex(sMenu[iLenMenu], charsmax(sMenu) - iLenMenu, "%s\y1. \wТеррорист^n%s\y2. \wКонтр-террорист^n^n%s\y5. \wАвто-выбор^n%s\y6. \wНаблюдатель^n^n", MENU_TAB, MENU_TAB, MENU_TAB, MENU_TAB);
	if(get_member(id, m_iTeam) != TEAM_UNASSIGNED) {
		bsKeys |= MENU_KEY_0;
		formatex(sMenu[iLenMenu], charsmax(sMenu) - iLenMenu, "%s\y0. \wВыход", MENU_TAB);
	}
	return show_menu(id, bsKeys, sMenu, TIME_MENU, "_team_select_menu");
}

public HandleTeamSelectMenu(const id, const iKey) {
	switch(iKey) {
		case 0: {
			rg_join_team(id, TEAM_TERRORIST);
			rg_set_user_team(id, TEAM_TERRORIST, MODEL_AUTO);
		}
		case 1: {
			rg_join_team(id, TEAM_CT);
			rg_set_user_team(id, TEAM_CT, MODEL_AUTO);
		}
		case 4: rg_join_team(id, TeamName:random_num(_:TEAM_TERRORIST, _:TEAM_SPECTATOR));
		case 5: rg_join_team(id, TEAM_SPECTATOR);
		case 9: return PLUGIN_HANDLED;
	}
	return PLUGIN_HANDLED;
}